Index: /LMDZ4/trunk/libf/phylmd/cpl_mod.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 1403)
@@ -24,4 +24,6 @@
   USE oasis
   USE write_field_phy
+  USE control_mod
+
   
 ! Global attributes
@@ -101,5 +103,4 @@
     INCLUDE "dimensions.h"
     INCLUDE "indicesol.h"
-    INCLUDE "control.h"
     INCLUDE "temps.h"
     INCLUDE "iniprint.h"
@@ -583,31 +584,31 @@
     DO ig = 1, knon
        cpl_sols(ig,cpl_index) = cpl_sols(ig,cpl_index) + &
-            swdown(ig)      / FLOAT(nexca)
+            swdown(ig)      / REAL(nexca)
        cpl_nsol(ig,cpl_index) = cpl_nsol(ig,cpl_index) + &
-            (lwdown(ig) + fluxlat(ig) +fluxsens(ig)) / FLOAT(nexca)
+            (lwdown(ig) + fluxlat(ig) +fluxsens(ig)) / REAL(nexca)
        cpl_rain(ig,cpl_index) = cpl_rain(ig,cpl_index) + &
-            precip_rain(ig) / FLOAT(nexca)
+            precip_rain(ig) / REAL(nexca)
        cpl_snow(ig,cpl_index) = cpl_snow(ig,cpl_index) + &
-            precip_snow(ig) / FLOAT(nexca)
+            precip_snow(ig) / REAL(nexca)
        cpl_evap(ig,cpl_index) = cpl_evap(ig,cpl_index) + &
-            evap(ig)        / FLOAT(nexca)
+            evap(ig)        / REAL(nexca)
        cpl_tsol(ig,cpl_index) = cpl_tsol(ig,cpl_index) + &
-            tsurf(ig)       / FLOAT(nexca)
+            tsurf(ig)       / REAL(nexca)
        cpl_fder(ig,cpl_index) = cpl_fder(ig,cpl_index) + &
-            fder(ig)        / FLOAT(nexca)
+            fder(ig)        / REAL(nexca)
        cpl_albe(ig,cpl_index) = cpl_albe(ig,cpl_index) + &
-            albsol(ig)      / FLOAT(nexca)
+            albsol(ig)      / REAL(nexca)
        cpl_taux(ig,cpl_index) = cpl_taux(ig,cpl_index) + &
-            taux(ig)        / FLOAT(nexca)
+            taux(ig)        / REAL(nexca)
        cpl_tauy(ig,cpl_index) = cpl_tauy(ig,cpl_index) + &
-            tauy(ig)        / FLOAT(nexca)      
+            tauy(ig)        / REAL(nexca)      
        cpl_windsp(ig,cpl_index) = cpl_windsp(ig,cpl_index) + &
-            windsp(ig)      / FLOAT(nexca)
+            windsp(ig)      / REAL(nexca)
        cpl_taumod(ig,cpl_index) =   cpl_taumod(ig,cpl_index) + &
-          SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / FLOAT (nexca)
+          SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / REAL (nexca)
 
        IF (carbon_cycle_cpl) THEN
           cpl_atm_co2(ig,cpl_index) = cpl_atm_co2(ig,cpl_index) + &
-               co2_send(knindex(ig))/ FLOAT(nexca) 
+               co2_send(knindex(ig))/ REAL(nexca) 
        END IF
      ENDDO
@@ -777,25 +778,25 @@
     DO ig = 1, knon
        cpl_sols(ig,cpl_index) = cpl_sols(ig,cpl_index) + &
-            swdown(ig)      / FLOAT(nexca)
+            swdown(ig)      / REAL(nexca)
        cpl_nsol(ig,cpl_index) = cpl_nsol(ig,cpl_index) + &
-            (lwdown(ig) + fluxlat(ig) +fluxsens(ig)) / FLOAT(nexca)
+            (lwdown(ig) + fluxlat(ig) +fluxsens(ig)) / REAL(nexca)
        cpl_rain(ig,cpl_index) = cpl_rain(ig,cpl_index) + &
-            precip_rain(ig) / FLOAT(nexca)
+            precip_rain(ig) / REAL(nexca)
        cpl_snow(ig,cpl_index) = cpl_snow(ig,cpl_index) + &
-            precip_snow(ig) / FLOAT(nexca)
+            precip_snow(ig) / REAL(nexca)
        cpl_evap(ig,cpl_index) = cpl_evap(ig,cpl_index) + &
-            evap(ig)        / FLOAT(nexca)
+            evap(ig)        / REAL(nexca)
        cpl_tsol(ig,cpl_index) = cpl_tsol(ig,cpl_index) + &
-            tsurf(ig)       / FLOAT(nexca)
+            tsurf(ig)       / REAL(nexca)
        cpl_fder(ig,cpl_index) = cpl_fder(ig,cpl_index) + &
-            fder(ig)        / FLOAT(nexca)
+            fder(ig)        / REAL(nexca)
        cpl_albe(ig,cpl_index) = cpl_albe(ig,cpl_index) + &
-            albsol(ig)      / FLOAT(nexca)
+            albsol(ig)      / REAL(nexca)
        cpl_taux(ig,cpl_index) = cpl_taux(ig,cpl_index) + &
-            taux(ig)        / FLOAT(nexca)
+            taux(ig)        / REAL(nexca)
        cpl_tauy(ig,cpl_index) = cpl_tauy(ig,cpl_index) + &
-            tauy(ig)        / FLOAT(nexca)     
+            tauy(ig)        / REAL(nexca)     
        cpl_taumod(ig,cpl_index) = cpl_taumod(ig,cpl_index) + &
-            SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / FLOAT(nexca) 
+            SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / REAL(nexca) 
     ENDDO
 
@@ -944,6 +945,6 @@
 !*************************************************************************************    
 !$OMP MASTER
-    cpl_rriv2D(:,:) = cpl_rriv2D(:,:) + rriv2D(:,:) / FLOAT(nexca)
-    cpl_rcoa2D(:,:) = cpl_rcoa2D(:,:) + rcoa2D(:,:) / FLOAT(nexca)
+    cpl_rriv2D(:,:) = cpl_rriv2D(:,:) + rriv2D(:,:) / REAL(nexca)
+    cpl_rcoa2D(:,:) = cpl_rcoa2D(:,:) + rcoa2D(:,:) / REAL(nexca)
 !$OMP END MASTER
 
@@ -998,5 +999,5 @@
 !*************************************************************************************    
 !$OMP MASTER
-    cpl_rlic2D(:,:) = cpl_rlic2D(:,:) + rlic2D(:,:) / FLOAT(nexca)
+    cpl_rlic2D(:,:) = cpl_rlic2D(:,:) + rlic2D(:,:) / REAL(nexca)
 !$OMP END MASTER
 
Index: /LMDZ4/trunk/libf/phylmd/cv30_routines.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv30_routines.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv30_routines.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -749,4 +749,5 @@
 
 #include "cv30param.h"
+      include 'iniprint.h'
 
 c inputs:
@@ -778,4 +779,7 @@
 c local variables:
       integer i,k,nn,j
+
+      CHARACTER (LEN=20) :: modname='cv30_compress'
+      CHARACTER (LEN=80) :: abort_message
 
 
@@ -820,6 +824,7 @@
 
       if (nn.ne.ncum) then
-         print*,'strange! nn not equal to ncum: ',nn,ncum
-         stop
+         write(lunout,*)'strange! nn not equal to ncum: ',nn,ncum
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       endif
 
Index: /LMDZ4/trunk/libf/phylmd/cv3_cine.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3_cine.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv3_cine.F	(revision 1403)
@@ -1,5 +1,8 @@
+!
+! $Id$
+!
         SUBROUTINE cv3_cine(nloc,ncum,nd,icb,inb
      :                      ,pbase,plcl,p,ph,tv,tvp
-     :                      ,cina,cinb)
+     :                      ,cina,cinb,plfc)
 
 ***************************************************************
@@ -26,5 +29,5 @@
 c
 c output
-      real cina(nloc),cinb(nloc)
+      real cina(nloc),cinb(nloc),plfc(nloc)
 c
 c local variables
@@ -34,5 +37,4 @@
       logical lswitch(nloc),lswitch1(nloc),lswitch2(nloc)
       logical exist_lfc(nloc)
-      real plfc(nloc)
       real dpmax
       real deltap,dcin
Index: /LMDZ4/trunk/libf/phylmd/cv3_inicp.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3_inicp.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv3_inicp.F	(revision 1403)
@@ -13,4 +13,6 @@
 c
       INTEGER iflag_clos
+      CHARACTER (LEN=20) :: modname='cv3_inicp'
+      CHARACTER (LEN=80) :: abort_message
 c
 c --   Mixing probability distribution functions
@@ -105,5 +107,6 @@
         if (abs(aire-1.0) .gt. 0.02) then
             print *,'WARNING:: AREA OF MIXING PDF IS::', aire
-            stop
+            abort_message = ''
+            CALL abort_gcm (modname,abort_message,1)
         else
             print *,'Area, mean & std deviation are ::', aire,mu,sigma
Index: /LMDZ4/trunk/libf/phylmd/cv3_inip.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3_inip.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv3_inip.F	(revision 1403)
@@ -12,4 +12,9 @@
 c
 c      INTEGER iflag_mix
+      include 'iniprint.h'
+
+      CHARACTER (LEN=20) :: modname='cv3_inip'
+      CHARACTER (LEN=80) :: abort_message
+
 c
 c --   Mixing probability distribution functions
@@ -104,6 +109,7 @@
 c
         if (abs(aire-1.0) .gt. 0.02) then
-            print *,'WARNING:: AREA OF MIXING PDF IS::', aire
-            stop
+            write(lunout,*)'WARNING:: AREA OF MIXING PDF IS::', aire
+            abort_message = ''
+            CALL abort_gcm (modname,abort_message,1)
         else
             print *,'Area, mean & std deviation are ::', aire,mu,sigma
Index: /LMDZ4/trunk/libf/phylmd/cv3_routines.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3_routines.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv3_routines.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header: /home/cvsroot/LMDZ4/libf/phylmd/cv3_routines.F,v 1.16 2008-11-06 16:29:35 lmdzadmin Exp $
+! $Id$
 !
 c
@@ -36,4 +36,7 @@
       real delt ! timestep (seconds)
 
+      CHARACTER (LEN=20) :: modname='cv3_param'
+      CHARACTER (LEN=80) :: abort_message
+
 c noff: integer limit for convection (nd-noff)
 c minorig: First level of convection
@@ -71,7 +74,6 @@
 c      dtcrit = -5.0
 c      tau    = 3000.
-cc      tau = 1800.
-c     tau= 2800.
-      tau=8000.
+      tau = 1800.
+cc      tau=8000.
       beta   = 1.0 - delt/tau
       alpha1 = 1.5e-3
@@ -767,4 +769,5 @@
 
 #include "cv3param.h"
+      include 'iniprint.h'
 
 c inputs:
@@ -797,4 +800,6 @@
       integer i,k,nn,j
 
+      CHARACTER (LEN=20) :: modname='cv3_compress'
+      CHARACTER (LEN=80) :: abort_message
 
       do 110 k=1,nl+1
@@ -839,6 +844,7 @@
 
       if (nn.ne.ncum) then
-         print*,'strange! nn not equal to ncum: ',nn,ncum
-         stop
+         write(lunout,*)'strange! nn not equal to ncum: ',nn,ncum
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       endif
 
@@ -2087,5 +2093,5 @@
 cc---end jyg---
 c
-c--------retour à la formulation originale d''Emanuel.
+c--------retour à la formulation originale d'Emanuel.
       b6=bfac*50.*sigd(il)*(ph(il,i)-ph(il,i+1))*sigt*afac
       c6=water(il,i+1)+bfac*wdtrain(il)
@@ -2093,6 +2099,12 @@
       if(c6.gt.0.0)then
        revap=0.5*(-b6+sqrt(b6*b6+4.*c6))
-       water(il,i)=revap*revap      !equation de conservation
+cjyg    Dans sa formulation originale, Emanuel calcule l'evaporation par:
+cc             evap(il,i)=sigt*afac*revap
+c     ce qui n'est pas correct. Dans cv_routines, la formulation a été modifiee.
+c     Ici,l'evaporation evap est simplement calculee par l'equation de
+c     conservation.
+       water(il,i)=revap*revap
       else
+cjyg----   Correction : si c6 <= 0, water(il,i)=0.
        water(il,i) = 0.
       endif
@@ -2338,5 +2350,5 @@
       real esum(nloc), fsum(nloc), gsum(nloc), hsum(nloc)
       real th_wake(nloc,nd)
-      real alpha_qpos(nloc)
+      real alpha_qpos(nloc),alpha_qpos1(nloc)
       real qcond(nloc,nd), nqcond(nloc,nd), wa(nloc,nd)  ! cld
       real siga(nloc,nd), sax(nloc,nd), mac(nloc,nd)      ! cld
@@ -3043,4 +3055,13 @@
        do il=1,ncum
         IF (iflag(il) .le. 1) THEN
+	IF (cvflag_grav) then
+        ex=0.01*grav*ment(il,inb(il),inb(il))
+     :      *(traent(il,inb(il),inb(il),j)-tra(il,inb(il),j))
+     :      /(ph(i l,inb(il))-ph(il,inb(il)+1))
+        ftra(il,inb(il),j)=ftra(il,inb(il),j)-ex
+        ftra(il,inb(il)-1,j)=ftra(il,inb(il)-1,j)
+     :       +ex*(ph(il,inb(il))-ph(il,inb(il)+1))
+     :          /(ph(il,inb(il)-1)-ph(il,inb(il)))
+	else
         ex=0.1*ment(il,inb(il),inb(il))
      :      *(traent(il,inb(il),inb(il),j)-tra(il,inb(il),j))
@@ -3050,4 +3071,5 @@
      :       +ex*(ph(il,inb(il))-ph(il,inb(il)+1))
      :          /(ph(il,inb(il)-1)-ph(il,inb(il)))
+        ENDIF   !cvflag grav
         ENDIF    !iflag
        enddo
@@ -3115,7 +3137,11 @@
 c        in order to ensure moisture positivity
       DO il = 1,ncum
+      alpha_qpos(il)=1.
        IF (iflag(il) .le. 1) THEN
-        alpha_qpos(il) = max(1. , -delt*fr(il,1)/
+        if (fr(il,1) .le. 0.) then
+            alpha_qpos(il) = max(alpha_qpos(il) ,
+     :	   (-delt*fr(il,1))/
      :     (s_wake(il)*rr_wake(il,1)+(1.-s_wake(il))*rr(il,1)))
+        end if
        ENDIF
       ENDDO
@@ -3123,6 +3149,10 @@
        DO il = 1,ncum
         IF (iflag(il) .le. 1) THEN
-        alpha_qpos(il) = max(alpha_qpos(il) , -delt*fr(il,i)/
+          IF (fr(il,i) .le. 0.) THEN
+           alpha_qpos1(il)=max(1. , (-delt*fr(il,i))/
      :     (s_wake(il)*rr_wake(il,i)+(1.-s_wake(il))*rr(il,i)))
+             IF (alpha_qpos1(il) .ge. alpha_qpos(il))
+     :           alpha_qpos(il)=alpha_qpos1(il)
+          ENDIF
         ENDIF
        ENDDO
Index: /LMDZ4/trunk/libf/phylmd/cv3a_compress.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3a_compress.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv3a_compress.F	(revision 1403)
@@ -76,4 +76,7 @@
       integer i,k,nn,j
 
+      CHARACTER (LEN=20) :: modname='cv3a_compress'
+      CHARACTER (LEN=80) :: abort_message
+
 
       do 110 k=1,nl+1
@@ -127,6 +130,7 @@
 
       if (nn.ne.ncum) then
-         print*,'WARNING nn not equal to ncum: ',nn,ncum
-         stop
+        print*,'WARNING nn not equal to ncum: ',nn,ncum
+        abort_message = ''
+        CALL abort_gcm (modname,abort_message,1)
       endif
 
@@ -157,5 +161,6 @@
       if (nn.ne.ncum) then
          print*,'WARNING nn not equal to ncum: ',nn,ncum
-         stop
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       endif
 
Index: /LMDZ4/trunk/libf/phylmd/cv3p1_closure.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3p1_closure.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv3p1_closure.F	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
       SUBROUTINE cv3p1_closure(nloc,ncum,nd,icb,inb
      :                      ,pbase,plcl,p,ph,tv,tvp,buoy
@@ -60,5 +63,5 @@
       integer nsupmax(nloc)
       real supcrit,temp(nloc,nd)
-      real P1(nloc),Pmin(nloc)
+      real P1(nloc),Pmin(nloc),plfc(nloc)
       real asupmax0(nloc)
       logical ok(nloc)
@@ -74,4 +77,7 @@
       real wb,sigmax
       data wb /2./, sigmax /0.1/
+
+      CHARACTER (LEN=20) :: modname='cv3p1_closure'
+      CHARACTER (LEN=80) :: abort_message
 c
 c      print *,' -> cv3p1_closure, Ale ',ale(1)
@@ -379,5 +385,5 @@
       CALL cv3_cine (nloc,ncum,nd,icb,inb
      :                      ,pbase,plcl,p,ph,tv,tvp
-     :                      ,cina,cinb)
+     :                      ,cina,cinb,plfc)
 c
       DO il = 1,ncum
@@ -489,6 +495,8 @@
       do k= 1,nl
        do il = 1,ncum
-!IM       IF (k .ge. icb(il) .and. k .le. inb(il)) THEN
-        IF (k .ge. icb(il)+1 .and. k .le. inb(il)) THEN
+!old       IF (k .ge. icb(il) .and. k .le. inb(il)) THEN
+!IM        IF (k .ge. icb(il)+1 .and. k .le. inb(il)) THEN
+       IF (k .ge. icb(il) .and. k .le. inb(il)         !cor jyg
+     $     .and. icb(il)+1 .le. inb(il)) THEN          !cor jyg
          cbmflim(il) = cbmflim(il)+MLIM(il,k)
         ENDIF
@@ -509,7 +517,9 @@
        cbmf1(il) = alp2(il)/(0.5*wb*wb-Cin(il))
        if(cbmf1(il).EQ.0.AND.alp2(il).NE.0.) THEN
-        print*,'cv3p1_closure cbmf1=0 and alp NE 0 il alp2 alp cin ',il,
+        write(lunout,*)
+     &  'cv3p1_closure cbmf1=0 and alp NE 0 il alp2 alp cin ',il,
      . alp2(il),alp(il),cin(il)
-        STOP 
+        abort_message = ''
+        CALL abort_gcm (modname,abort_message,1)
        endif
        cbmfmax(il) = sigmax*wb2(il)*100.*p(il,icb(il))
@@ -540,8 +550,10 @@
         do il = 1,ncum
          IF ( k .ge. icb(il)+1 .AND. k .le. inb(il)) THEN
-         sig(il,k) = beta*sig(il,k)+(1.-beta)*coef(il)*siglim(il,k)
-cc         sig(il,k) = beta*sig(il,k)+siglim(il,k)
-         w0(il,k) = beta*w0(il,k)  +(1.-beta)*wlim(il,k)
-         AMU=SIG(il,k)*W0(il,k)
+         amu=beta*sig(il,k)*w0(il,k)+
+     :   (1.-beta)*coef(il)*siglim(il,k)*wlim(il,k)
+         w0(il,k) = wlim(il,k)
+         w0(il,k) =max(w0(il,k),1.e-10)
+         sig(il,k)=amu/w0(il,k)
+         sig(il,k)=min(sig(il,k),1.)
 cc         amu = 0.5*(SIG(il,k)+sigold(il,k))*W0(il,k)
          M(il,k)=AMU*0.007*P(il,k)*(PH(il,k)-PH(il,k+1))/TV(il,k)
Index: /LMDZ4/trunk/libf/phylmd/cv_routines.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv_routines.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cv_routines.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE cv_param(nd)
@@ -38,4 +38,6 @@
 #include "cvparam.h"
       integer nd
+      CHARACTER (LEN=20) :: modname='cv_routines'
+      CHARACTER (LEN=80) :: abort_message
 
 c noff: integer limit for convection (nd-noff)
@@ -429,4 +431,8 @@
 c local variables:
       integer i,k,nn
+      CHARACTER (LEN=20) :: modname='cv_compress'
+      CHARACTER (LEN=80) :: abort_message
+
+      include 'iniprint.h'
 
 
@@ -456,6 +462,7 @@
 
       if (nn.ne.ncum) then
-         print*,'strange! nn not equal to ncum: ',nn,ncum
-         stop
+         write(lunout,*)'strange! nn not equal to ncum: ',nn,ncum
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
       endif
 
Index: /LMDZ4/trunk/libf/phylmd/cva_driver.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cva_driver.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/cva_driver.F	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
       SUBROUTINE cva_driver(len,nd,ndp1,ntra,nloc,
      &                   iflag_con,iflag_mix,
@@ -106,4 +109,6 @@
 #include "dimensions.h"
 ccccc#include "dimphy.h"
+      include 'iniprint.h'
+
 c
 c Input
@@ -151,5 +156,5 @@
       real Ma1(len,nd)
       real mip1(len,nd)
-!      real Vprecip1(len,nd) Correction abderr le 23 03 10
+!      real Vprecip1(len,nd)
       real Vprecip1(len,nd+1)
       real upwd1(len,nd)
@@ -421,4 +426,6 @@
       logical, save :: first=.true.
 c$OMP THREADPRIVATE(first)
+      CHARACTER (LEN=20) :: modname='cva_driver'
+      CHARACTER (LEN=80) :: abort_message
 
 c
@@ -566,7 +573,8 @@
 c test niveaux couche alimentation KE
        if(sig1feed1.eq.sig2feed1) then
-               print*,'impossible de choisir sig1feed=sig2feed'
-               print*,'changer la valeur de sig2feed dans physiq.def'
-       stop
+         write(lunout,*)'impossible de choisir sig1feed=sig2feed'
+         write(lunout,*)'changer la valeur de sig2feed dans physiq.def'
+         abort_message = ''
+         CALL abort_gcm (modname,abort_message,1)
        endif
 c
Index: /LMDZ4/trunk/libf/phylmd/fisrtilp.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/fisrtilp.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/fisrtilp.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -7,5 +7,6 @@
      s                   pfrac_impa, pfrac_nucl, pfrac_1nucl,
      s                   frac_impa, frac_nucl,
-     s                   prfl, psfl, rhcl)
+     s                   prfl, psfl, rhcl, zqta, fraca,
+     s                   ztv, zpspsk, ztla, zthl, iflag_cldcon)
 
 c
@@ -41,5 +42,12 @@
       REAL snow(klon) ! neige (mm/s)
       REAL prfl(klon,klev+1) ! flux d'eau precipitante aux interfaces (kg/m2/s)
-      REAL psfl(klon,klev+1) ! flux d'eau precipitante aux interfaces (kg/m2/s)
+      REAL psfl(klon,klev+1) ! flux d'eau precipitante aux interfaces (kg/m2/s) 
+      REAL ztv(klon,klev)
+      REAL zqta(klon,klev),fraca(klon,klev) 
+      REAL sigma1(klon,klev),sigma2(klon,klev)
+      REAL qltot(klon,klev),ctot(klon,klev)
+      REAL zpspsk(klon,klev),ztla(klon,klev)
+      REAL zthl(klon,klev)
+
 cAA
 c Coeffients de fraction lessivee : pour OFF-LINE
@@ -63,5 +71,6 @@
 
       INTEGER ninter ! sous-intervals pour la precipitation
-      INTEGER ncoreczq
+      INTEGER ncoreczq  
+      INTEGER iflag_cldcon
       PARAMETER (ninter=5)
       LOGICAL evap_prec ! evaporation de la pluie
@@ -72,5 +81,6 @@
       real zpdf_sig(klon),zpdf_k(klon),zpdf_delta(klon)
       real Zpdf_a(klon),zpdf_b(klon),zpdf_e1(klon),zpdf_e2(klon)
-      real erf
+      real erf   
+      REAL qcloud(klon)
 c
       LOGICAL cpartiel ! condensation partielle
@@ -82,5 +92,5 @@
 c
       INTEGER i, k, n, kk
-      REAL zqs(klon), zdqs(klon), zdelta, zcor, zcvm5
+      REAL zqs(klon), zdqs(klon), zdelta, zcor, zcvm5   
       REAL zrfl(klon), zrfln(klon), zqev, zqevt
       REAL zoliq(klon), zcond(klon), zq(klon), zqn(klon), zdelq
@@ -130,4 +140,5 @@
       zdelq=0.0
       
+      print*,'CLOUDTH4 A. JAM'
       IF (appel1er) THEN
 c
@@ -135,5 +146,5 @@
          PRINT*, 'fisrtilp, evap_prec:', evap_prec
          PRINT*, 'fisrtilp, cpartiel:', cpartiel
-         IF (ABS(dtime/FLOAT(ninter)-360.0).GT.0.001) THEN
+         IF (ABS(dtime/REAL(ninter)-360.0).GT.0.001) THEN
           PRINT*, 'fisrtilp: Ce n est pas prevu, voir Z.X.Li', dtime
           PRINT*, 'Je prefere un sous-intervalle de 6 minutes'
@@ -322,4 +333,5 @@
 c de l'eau condensee:
 c
+
       IF (cpartiel) THEN
 
@@ -351,6 +363,21 @@
                 zq(i)=1.e-15
               endif
-           enddo
-           do i=1,klon
+           enddo 
+
+              if (iflag_cldcon.eq.5) then
+
+                 call cloudth(klon,klev,k,ztv,
+     .           zq,zqta,fraca,
+     .           qcloud,ctot,zpspsk,paprs,ztla,zthl,
+     .           ratqs,zqs,t)
+
+                 do i=1,klon
+                 rneb(i,k)=ctot(i,k)
+                 zqn(i)=qcloud(i)
+                 enddo
+
+              else
+
+            do i=1,klon
             zpdf_sig(i)=ratqs(i,k)*zq(i)
             zpdf_k(i)=-sqrt(log(1.+(zpdf_sig(i)/zq(i))**2))
@@ -372,5 +399,7 @@
             endif
             
-           enddo
+           enddo 
+
+         endif ! iflag_cldcon
 
         endif ! iflag_pdf
@@ -436,5 +465,5 @@
          zfice(i) = zfice(i)**nexpo
          zneb(i) = MAX(rneb(i,k), seuil_neb)
-         radliq(i,k) = zoliq(i)/FLOAT(ninter+1)
+         radliq(i,k) = zoliq(i)/REAL(ninter+1)
       ENDIF
       ENDDO
@@ -453,13 +482,13 @@
                 zcl   =cld_lc_con
                 zct   =1./cld_tau_con
-                zfroi    = dtime/FLOAT(ninter)/zdz(i)*zoliq(i)
+                zfroi    = dtime/REAL(ninter)/zdz(i)*zoliq(i)
      .              *fallvc(zrhol(i)) * zfice(i)
              else
                 zcl   =cld_lc_lsc
                 zct   =1./cld_tau_lsc
-                zfroi    = dtime/FLOAT(ninter)/zdz(i)*zoliq(i)
+                zfroi    = dtime/REAL(ninter)/zdz(i)*zoliq(i)
      .              *fallvs(zrhol(i)) * zfice(i)
              endif
-             zchau    = zct   *dtime/FLOAT(ninter) * zoliq(i)
+             zchau    = zct   *dtime/REAL(ninter) * zoliq(i)
      .         *(1.0-EXP(-(zoliq(i)/zneb(i)/zcl   )**2)) *(1.-zfice(i))
              ztot    = zchau    + zfroi
@@ -468,5 +497,5 @@
          ztot    = MIN(ztot,zoliq(i))
          zoliq(i) = MAX(zoliq(i)-ztot   , 0.0)
-         radliq(i,k) = radliq(i,k) + zoliq(i)/FLOAT(ninter+1)
+         radliq(i,k) = radliq(i,k) + zoliq(i)/REAL(ninter+1)
       ENDIF
       ENDDO
Index: /LMDZ4/trunk/libf/phylmd/fisrtilp_tr.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/fisrtilp_tr.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/fisrtilp_tr.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -140,5 +140,5 @@
          PRINT*, 'fisrtilp, evap_prec:', evap_prec
          PRINT*, 'fisrtilp, cpartiel:', cpartiel
-         IF (ABS(dtime/FLOAT(ninter)-360.0).GT.0.001) THEN
+         IF (ABS(dtime/REAL(ninter)-360.0).GT.0.001) THEN
           PRINT*, 'fisrtilp: Ce n est pas prevu, voir Z.X.Li', dtime
           PRINT*, 'Je prefere un sous-intervalle de 6 minutes'
@@ -335,5 +335,5 @@
          zfice(i) = zfice(i)**nexpo
          zneb(i) = MAX(rneb(i,k), seuil_neb)
-         radliq(i,k) = zoliq(i)/FLOAT(ninter+1)
+         radliq(i,k) = zoliq(i)/REAL(ninter+1)
       ENDIF
       ENDDO
@@ -342,8 +342,8 @@
       DO i = 1, klon
       IF (rneb(i,k).GT.0.0) THEN
-         zchau(i) = ct*dtime/FLOAT(ninter) * zoliq(i)
+         zchau(i) = ct*dtime/REAL(ninter) * zoliq(i)
      .          * (1.0-EXP(-(zoliq(i)/zneb(i)/cl)**2)) *(1.-zfice(i))
          zrhol(i) = zrho(i) * zoliq(i) / zneb(i)
-         zfroi(i) = dtime/FLOAT(ninter)/zdz(i)*zoliq(i)
+         zfroi(i) = dtime/REAL(ninter)/zdz(i)*zoliq(i)
      .              *fallv(zrhol(i)) * zfice(i)
          ztot(i) = zchau(i) + zfroi(i)
@@ -351,5 +351,5 @@
          ztot(i) = MIN(MAX(ztot(i),0.0),zoliq(i))
          zoliq(i) = MAX(zoliq(i)-ztot(i), 0.0)
-         radliq(i,k) = radliq(i,k) + zoliq(i)/FLOAT(ninter+1)
+         radliq(i,k) = radliq(i,k) + zoliq(i)/REAL(ninter+1)
       ENDIF
       ENDDO
Index: /LMDZ4/trunk/libf/phylmd/hines_gwd.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/hines_gwd.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/hines_gwd.F	(revision 1403)
@@ -847,5 +847,5 @@
 C  Use horizontal isotropy to calculate azimuthal variances at bottom level.
 C
-      AZFAC = 1. / FLOAT(NAZ)
+      AZFAC = 1. / REAL(NAZ)
       DO 20 N = 1,NAZ
         DO 10 I = IL1,IL2
Index: /LMDZ4/trunk/libf/phylmd/ini_bilKP_ave.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_bilKP_ave.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_bilKP_ave.h	(revision 1403)
@@ -1,4 +1,4 @@
 c
-c $Header$
+c $Id$
 c
       IF (ok_journe) THEN
@@ -17,5 +17,5 @@
 cym         ENDDO
          DO ll=1,klev
-            znivsig(ll)=float(ll)
+            znivsig(ll)=REAL(ll)
          ENDDO
 cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
Index: /LMDZ4/trunk/libf/phylmd/ini_bilKP_ins.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_bilKP_ins.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_bilKP_ins.h	(revision 1403)
@@ -1,4 +1,4 @@
 c
-c $Header$
+c $Id$
 c
       IF (ok_journe) THEN
@@ -17,5 +17,5 @@
 cym         ENDDO
          DO ll=1,klev
-            znivsig(ll)=float(ll)
+            znivsig(ll)=REAL(ll)
          ENDDO
 cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
Index: /LMDZ4/trunk/libf/phylmd/ini_histISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histISCCP.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_histISCCP.h	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       IF (ok_isccp) THEN
@@ -49,5 +49,5 @@
 c
         DO l=1, ncol(n)
-          vertlev(l,n)=float(l)
+          vertlev(l,n)=REAL(l)
         ENDDO !ncol
 c
Index: /LMDZ4/trunk/libf/phylmd/ini_histday_seri.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histday_seri.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_histday_seri.h	(revision 1403)
@@ -1,4 +1,4 @@
 c
-c $Header$
+c $Id$
 c
 cym Ne fonctionnera pas en mode parallele
@@ -19,5 +19,5 @@
          ENDDO
          DO ll=1,klev
-            znivsig(ll)=float(ll)
+            znivsig(ll)=REAL(ll)
          ENDDO
          CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
Index: /LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c$OMP MASTER
@@ -17,5 +17,5 @@
 cym         ENDDO
          DO ll=1,klev
-            znivsig(ll)=float(ll)
+            znivsig(ll)=REAL(ll)
          ENDDO
 cym         CALL gr_fi_ecrit(1,klon,iim,jjmp1,rlat,zx_lat)
Index: /LMDZ4/trunk/libf/phylmd/ini_histrac.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histrac.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_histrac.h	(revision 1403)
@@ -14,4 +14,7 @@
      CALL histdef(nid_tra, "aire", "Grid area", "-",              &
           iim,jj_nb,nhori, 1,1,1, -99, 32,"once",  zsto,zout)
+     CALL histdef(nid_tra, "zmasse", "column density of air in cell", &
+          "kg m-2", iim, jj_nb, nhori, klev, 1, klev, nvert, 32, "ave(X)", &
+          zsto,zout)
 
 !TRACEURS
@@ -91,8 +94,8 @@
           "inst(X)",  zout,zout)
 ! DIVERS
-     CALL histdef(nid_tra, "pplay", "flux u mont","-",     &
+     CALL histdef(nid_tra, "pplay", "pressure","-",        &
           iim,jj_nb,nhori, klev,1,klev,nvert, 32,          &
           "inst(X)", zout,zout)
-     CALL histdef(nid_tra, "t", "flux u mont","-",         &
+     CALL histdef(nid_tra, "T", "temperature","K",         &
           iim,jj_nb,nhori, klev,1,klev,nvert, 32,          &
           "inst(X)", zout,zout)
Index: /LMDZ4/trunk/libf/phylmd/ini_undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_undefSTD.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_undefSTD.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 
Index: /LMDZ4/trunk/libf/phylmd/ini_wake.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_wake.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/ini_wake.F	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
       SUBROUTINE INI_WAKE(wape,fip,it_wape_prescr,
      :     wape_prescr, fip_prescr, alp_bl_prescr, ale_bl_prescr)
@@ -23,4 +26,6 @@
 c   wape_prescr    : valeur prescrite de la WAPE.
 c   fip_prescr     : valeur prescrite de la FIP.
+c   ale_bl_prescr  : valeur prescrite de la Ale de PBL.
+c   alp_bl_prescr  : valeur prescrite de la Alp de PBL.
 c
 c Variables internes
@@ -29,17 +34,12 @@
 c   w  = WAPE lue
 c   f  = FIP lue
+c   alebl  = Ale de PBL lue
+c   alpbl  = Alp de PBL lue
 c
+      include 'iniprint.h'
 cdeclarations
       real ale_bl_prescr
       real alp_bl_prescr
       real it
-cCR: on rajoute ale et alp de la PBL precrits
-c     open (99,file='wake.data',form='formatted')
-c     read (99,*) it
-c     read (99,*) w
-c     read (99,*) f
-c     read (99,*) u
-c     read (99,*) p
-c     close (99)
 
 ! FH A mettre si besoin dans physiq.def
@@ -48,8 +48,19 @@
       w=4.
       f=0.1
-      u=0.1
-      p=4.
+      alebl=4.
+      alpbl=0.1
 c
-      print *,' it,w ',it,w
+cCR: on rajoute ale et alp de la PBL precrits
+      open (99,file='ini_wake_param.data',form='formatted',
+     s      status='old',err=902)
+      read (99,*) it
+      read (99,*) w
+      read (99,*) f
+      read (99,*,end=901) alebl
+      read (99,*,end=901) alpbl
+901   close (99)
+902   continue
+c
+      write(lunout,*)' it,wape ',it,wape
       it_wape_prescr = it
       if (w .lt. 0) then
@@ -61,7 +72,7 @@
       endif
 c
-      print *,' u,p ',u,p
-      alp_bl_prescr=u
-      ale_bl_prescr=p
+      write(lunout,*)' alebl, alpbl ',alebl,alpbl
+      ale_bl_prescr=alebl
+      alp_bl_prescr=alpbl
       print *,'Initialisation de la poche : WAPE, FIP imposees ='
      $               ,wape_prescr, fip_prescr
